      PROGRAM TPZPOSV
*
*       ணࠬ PZPOSV
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            DLEN_, IA, JA, IB, JB, M, N, MB, NB, RSRC,
     $                   CSRC, MXLLDA, MXLLDB, NRHS, NBRHS, NOUT,
     $                   MXLOCR, MXLOCC, MXRHSC
      PARAMETER          ( DLEN_ = 9, IA = 1, JA = 1, IB = 1, JB = 1,
     $                   M = 9, N = 9, MB = 2, NB = 2, RSRC = 0,
     $                   CSRC = 0, MXLLDA = 5, MXLLDB = 5, NRHS = 1,
     $                   NBRHS = 1, NOUT = 6, MXLOCR = 5, MXLOCC = 4,
     $                   MXRHSC = 1 )
      DOUBLE COMPLEX     ONE
      PARAMETER          ( ONE = (1.0D+0,0.D0) )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'L' )
*
*  ६ ..
      INTEGER            ICTXT, INFO, MYCOL, MYROW, NPCOL, NPROW
      DOUBLE PRECISION   ANORM, BNORM, EPS, RESID, XNORM
*
*  ᨢ ..
      INTEGER            DESCA( DLEN_ ), DESCB( DLEN_ )
      DOUBLE COMPLEX     A( MXLLDA, MXLOCC ), A0( MXLLDA, MXLOCC ),
     $                   B( MXLLDB, MXRHSC ), B0( MXLLDB, MXRHSC ),
     $                   WORK( MXLOCR ), WORK1(2)
*
* 譨 㭪樨 ..
      DOUBLE PRECISION   PDLAMCH, PZLANGE
      EXTERNAL           PDLAMCH, PZLANGE
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                   DESCINIT, PDMATINIT, PZGEMM, PZPOSV, PZLACPY,
     $                   PZLAPRNT, SL_INIT
*
* ७ 㭪樨 ..
      INTRINSIC          DBLE
*
*   DATA ..
      DATA               NPROW / 2 / , NPCOL / 3 /
*
* 믮塞 
*
* 樠 ⪨ ᮢ
*
      CALL SL_INIT( ICTXT, NPROW, NPCOL )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨   ⪨ ᮢ, 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 10
*
* ।   ⪥ ᮢ
*
* 樠 ਯ஢   A  B
*
      CALL DESCINIT( DESCA, M, N, MB, NB, RSRC, CSRC, ICTXT, MXLLDA,
     $               INFO )
      CALL DESCINIT( DESCB, N, NRHS, NB, NBRHS, RSRC, CSRC, ICTXT,
     $               MXLLDB, INFO )
*
*   A  B  ।  ⪥ ᮢ
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB, INFO )
*
* ஢ A  B  楫 ஢ન 離
*
      CALL PZLACPY( 'All', N, N, A, 1, 1, DESCA, A0, 1, 1, DESCA )
      CALL PZLACPY( 'All', N, NRHS, B, 1, 1, DESCB, B0, 1, 1, DESCB )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9999 )
         WRITE( NOUT, FMT = 9998 )M, N, MB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) ' A'
      END IF
 9985 FORMAT( / 9I5 /)
 9988 FORMAT( / ' UPLO = ', A /)
*
      CALL PZLAPRNT( M, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
      WRITE( NOUT, FMT = * ) ' B'
      END IF
      CALL PZLAPRNT( N, NRHS, B, IB, JB, DESCB, 0, 0, 'B', NOUT, WORK1 )
*
* 맮 ணࠬ 
*
* 襭  ⥬ A * X = B
*
      CALL  PZPOSV ( UPLO, N, NRHS, A, IA, JA, DESCA,
     $               B, IB, JB, DESCB, INFO)
*
*  襭 X ( ᨢ B)
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = * ) ' 襭 X'
      END IF
*
      CALL PZLAPRNT( N, NRHS, B, IB, JB, DESCB, 0, 0, 'X', NOUT, WORK1 )
*
* ᫥ 離 ||A * X  - B|| / ( ||X|| * ||A|| * eps * N )
*
      EPS = PDLAMCH( ICTXT, 'Epsilon' )
      ANORM = PZLANGE( 'I', N, N, A, 1, 1, DESCA, WORK )
      BNORM = PZLANGE( 'I', N, NRHS, B, 1, 1, DESCB, WORK )
      CALL PZGEMM( 'N', 'N', N, NRHS, N, ONE, A0, 1, 1, DESCA, B, 1, 1,
     $             DESCB, -ONE, B0, 1, 1, DESCB )
      XNORM = PZLANGE( 'I', N, NRHS, B0, 1, 1, DESCB, WORK )
      RESID = XNORM / ( ANORM*BNORM*EPS*DBLE( N ) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( RESID.LT.10.0D+0 ) THEN
            WRITE( NOUT, FMT = 9995 )
            WRITE( NOUT, FMT = 9993 )RESID
         ELSE
            WRITE( NOUT, FMT = 9994 )
            WRITE( NOUT, FMT = 9993 )RESID
         END IF
      END IF
*
* ᢮ ⪨ ᮢ
*
* ᢮ ⥪ BLACS'
*
      CALL BLACS_GRIDEXIT( ICTXT )
   10 CONTINUE
*
* 室  BLACS
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( / '  ணࠬ PZPOSV' )
 9998 FORMAT( / ' 襭 A X = B ,' //
     $      '  A - ନ⮢ ⥫쭮 ।  ',
     $      I2, '  ', I2,',' /
     $       '      ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
 9995 FORMAT( /' 離 ')
 9994 FORMAT( /' 離 ')
 9993 FORMAT( / '||A*x - b|| / ( ||x||*||A||*eps*N ) = ', 1P, E16.8 )
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB,
     $                      INFO )
*
* PDMATINIT   ।  A  B
*          ⪥ ᮢ 2 x 3
*
* ࠬ
      INTEGER            DESCA( * ), DESCB( * ), N, IA, JA, IB, JB,
     $                   INFO
      DOUBLE COMPLEX     A( * ), B( * )
*
*  ६
      INTEGER            I, J
      DOUBLE COMPLEX     T, MO, Z
*
* 譨 ணࠬ
      EXTERNAL           PZELSET
*
* 믮塞 
*
      T = (2.0D0, 0.D0)
      Z = (0.0D0, 0.D0)
      MO = (-1.0D0, 0.D0)
*
      DO 20 J = 1, N
      DO 10 I = 1, N
         IF( I.EQ.J ) THEN
             CALL PZELSET( A, I, J, DESCA, T )
         ELSE
             CALL PZELSET( A, I, J ,DESCA, Z )
         END IF
   10 CONTINUE
   20 CONTINUE
*
      CALL PZELSET( A, 9, 9, DESCA, (1.0D0, 0.0D0) )
*
      DO 40 I = 1, N-1
         J = I + 1
         CALL PZELSET( A, I, J, DESCA, MO )
   40 CONTINUE
*
      DO 50 J = 1, N-1
         I = J + 1
         CALL PZELSET( A, I, J, DESCA, MO )
   50 CONTINUE
*
      J = 1
      DO 30 I = 1, N
        CALL PZELSET( B, I, J, DESCB, Z )
   30 CONTINUE
*
      CALL PZELSET( B, 9, 1, DESCB,  (1.0D0, 0.0D0) )
*
      RETURN
      END
